//----------------------------------------------------------------------------
// OptionsForm.cs
//
// Options form for C1ReportDesigner application
//
// This is a part of the C1ReportDesigner package.
// Copyright (C) GrapeCity, Inc
// All rights reserved.
//
// This source code is intended as a supplement to the
// C1ReportDesigner control and related documentation 
// provided with the product.
// See these sources for detailed information regarding the
// C1ReportDesigner product.
//----------------------------------------------------------------------------
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ReportDesignerApp
{
	using C1.C1Report;

	/// <summary>
	/// Summary description for ReportInfoForm.
	/// </summary>
	public class ReportInfoForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox _txtTitle;
		private System.Windows.Forms.TextBox _txtAuthor;
		private System.Windows.Forms.TextBox _txtSubject;
		private System.Windows.Forms.TextBox _txtCreator;
		private System.Windows.Forms.TextBox _txtKeywords;
		private System.Windows.Forms.Button _btnOK;
		private System.Windows.Forms.Button _btnCancel;
		private System.Windows.Forms.CheckBox _chkApplyToAll;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ReportInfoForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();


            //
            AutoScaleMode = AutoScaleMode.None;
            Font = MainForm.DefaultAppFont;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this._txtTitle = new System.Windows.Forms.TextBox();
            this._txtAuthor = new System.Windows.Forms.TextBox();
            this._txtSubject = new System.Windows.Forms.TextBox();
            this._txtCreator = new System.Windows.Forms.TextBox();
            this._txtKeywords = new System.Windows.Forms.TextBox();
            this._btnOK = new System.Windows.Forms.Button();
            this._btnCancel = new System.Windows.Forms.Button();
            this._chkApplyToAll = new System.Windows.Forms.CheckBox();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(16, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(80, 16);
            this.label1.TabIndex = 0;
            this.label1.Text = "&Title";
            this.label1.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(16, 48);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(80, 16);
            this.label2.TabIndex = 2;
            this.label2.Text = "&Author";
            this.label2.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(16, 80);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(80, 16);
            this.label3.TabIndex = 4;
            this.label3.Text = "&Subject";
            this.label3.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(16, 112);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(80, 16);
            this.label4.TabIndex = 6;
            this.label4.Text = "&Creator";
            this.label4.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(16, 144);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(80, 16);
            this.label5.TabIndex = 8;
            this.label5.Text = "&Keywords";
            this.label5.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
            // 
            // _txtTitle
            // 
            this._txtTitle.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this._txtTitle.Location = new System.Drawing.Point(104, 16);
            this._txtTitle.Name = "_txtTitle";
            this._txtTitle.Size = new System.Drawing.Size(296, 20);
            this._txtTitle.TabIndex = 1;
            // 
            // _txtAuthor
            // 
            this._txtAuthor.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this._txtAuthor.Location = new System.Drawing.Point(104, 48);
            this._txtAuthor.Name = "_txtAuthor";
            this._txtAuthor.Size = new System.Drawing.Size(296, 20);
            this._txtAuthor.TabIndex = 3;
            // 
            // _txtSubject
            // 
            this._txtSubject.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this._txtSubject.Location = new System.Drawing.Point(104, 80);
            this._txtSubject.Name = "_txtSubject";
            this._txtSubject.Size = new System.Drawing.Size(296, 20);
            this._txtSubject.TabIndex = 5;
            // 
            // _txtCreator
            // 
            this._txtCreator.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this._txtCreator.Location = new System.Drawing.Point(104, 112);
            this._txtCreator.Name = "_txtCreator";
            this._txtCreator.Size = new System.Drawing.Size(296, 20);
            this._txtCreator.TabIndex = 7;
            // 
            // _txtKeywords
            // 
            this._txtKeywords.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this._txtKeywords.Location = new System.Drawing.Point(104, 144);
            this._txtKeywords.Multiline = true;
            this._txtKeywords.Name = "_txtKeywords";
            this._txtKeywords.Size = new System.Drawing.Size(296, 64);
            this._txtKeywords.TabIndex = 9;
            // 
            // _btnOK
            // 
            this._btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this._btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
            this._btnOK.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this._btnOK.Location = new System.Drawing.Point(216, 264);
            this._btnOK.Name = "_btnOK";
            this._btnOK.Size = new System.Drawing.Size(88, 24);
            this._btnOK.TabIndex = 11;
            this._btnOK.Text = "&OK";
            // 
            // _btnCancel
            // 
            this._btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this._btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this._btnCancel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this._btnCancel.Location = new System.Drawing.Point(312, 264);
            this._btnCancel.Name = "_btnCancel";
            this._btnCancel.Size = new System.Drawing.Size(88, 24);
            this._btnCancel.TabIndex = 12;
            this._btnCancel.Text = "&Cancel";
            // 
            // _chkApplyToAll
            // 
            this._chkApplyToAll.Location = new System.Drawing.Point(104, 216);
            this._chkApplyToAll.Name = "_chkApplyToAll";
            this._chkApplyToAll.Size = new System.Drawing.Size(296, 24);
            this._chkApplyToAll.TabIndex = 10;
            this._chkApplyToAll.Text = "Apply this information to all reports.";
            // 
            // ReportInfoForm
            // 
            this.AcceptButton = this._btnOK;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.CancelButton = this._btnCancel;
            this.ClientSize = new System.Drawing.Size(418, 296);
            this.Controls.Add(this._chkApplyToAll);
            this.Controls.Add(this._btnOK);
            this.Controls.Add(this._btnCancel);
            this.Controls.Add(this._txtTitle);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.label5);
            this.Controls.Add(this._txtAuthor);
            this.Controls.Add(this._txtSubject);
            this.Controls.Add(this._txtCreator);
            this.Controls.Add(this._txtKeywords);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "ReportInfoForm";
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Text = "Report Information";
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private ReportInfo _reportInfo;
		public ReportInfo ReportInfo
		{
			get { return _reportInfo; }
		}

        public bool ApplyToAll
		{
			get { return _chkApplyToAll.Checked; }
		}
		
        public DialogResult ShowDialog(C1Report rpt)
		{
			_reportInfo = rpt.ReportInfo.Clone();

			_txtTitle.DataBindings.Add   (new Binding("Text", ReportInfo, "Title"));
			_txtAuthor.DataBindings.Add  (new Binding("Text", ReportInfo, "Author"));
			_txtSubject.DataBindings.Add (new Binding("Text", ReportInfo, "Subject"));
			_txtCreator.DataBindings.Add (new Binding("Text", ReportInfo, "Creator"));
			_txtKeywords.DataBindings.Add(new Binding("Text", ReportInfo, "Keywords"));
 
			return base.ShowDialog();
		}
	}
}
