//----------------------------------------------------------------------------
// IC1ReportImportFilter.cs
//
// Interface used by import filters in the C1ReportDesigner app
// Import filters should implement this interface. Currently, there are
// two import filters in the C1ReportDesigner app: the AccessFilter and
// CrystalFilter classes.
//
// This is a part of the C1ReportDesigner package.
// Copyright (C) GrapeCity, Inc
// All rights reserved.
//
// This source code is intended as a supplement to the
// C1ReportDesigner control and related documentation 
// provided with the product.
// See these sources for detailed information regarding the
// C1ReportDesigner product.
//----------------------------------------------------------------------------
using System;
using System.Collections;

namespace ReportDesignerApp.Util
{
	/// <summary>
    /// Interface used by import filters in the C1ReportDesigner app.
	/// </summary>
	internal interface IC1ReportImportFilter
	{
		// main method
        // populates reportList with imported reports, returns true to
        // clear existing reports or false to add new reports to the list
		bool Import(string fileName, ArrayList reportList);

		// for UI updates
		event EventHandler Loading;
	}
}
